/****************************************************************************************
// UART0_PIN76,BAUD=9600, ÿ1뷢һ,ÿ116ֽ,һΪз,8ѭ
// 8ַΪ 0x41,0x43,0x45,0x47,0x49,0x4B,0x4D,0x4F, ACEGIKMO
// PIN88PIN90һ, 8λݸʽ, ɴʾЩ.
 * Copyright (C) 2013 Nuvoton(SH) Technology Corp. All rights reserved.
 ******************************************************************************/
#include  "nano1xx.h"

uint8_t Data[116] = "01_34_56789ABCDEFGHIJKLMNOPQRSTVUWXYZabcdefghijklmnopqrstvuwxyzABCDEFGHIJKLMNOPQRSTVUWXYZabcdefghijklmnopqrstvuwxyz" ;

////  ///////////////////////////////////////////////////////////////////////////
void UnlockReg(void)
{
  while(!(GCR->RegLockAddr & 1)){
    GCR->RegLockAddr = 0x59 ; 
    GCR->RegLockAddr = 0x16 ; 
    GCR->RegLockAddr = 0x88 ;
  }
} 
//// ϵͳʱӳʼ /////////////////////////////////////////////////////////////////
void SysClkInit(void)
{
  UnlockReg();
  CLK->PWRCTL  = CLK_PWRCTL_PWRDOWN_EN | CLK_PWRCTL_DELY_EN | CLK_PWRCTL_HIRC_EN  | CLK_PWRCTL_LXT_EN ; 
  CLK->CLKDIV0 = 0 ;
  CLK->CLKSEL1 = CLK_CLKSEL1_TMR0_HIRC | CLK_CLKSEL1_UART_HIRC ;  
  CLK->AHBCLK  = CLK_AHBCLK_SRAM_EN | CLK_AHBCLK_GPIO_EN ;
  CLK->APBCLK  = CLK_APBCLK_TMR0_EN | CLK_APBCLK_UART0_EN ;
  CLK->CLKSEL0 = CLK_CLKSEL0_HCLK_HIRC ;
}
//// GPIOڳʼ ///////////////////////////////////////////////////////////////////
void GpioInit(void)
{
  GCR->PA_H_MFP = PA15_MFP_UART0_TX | PA14_MFP_UART0_RX ;
  GCR->PB_L_MFP = PB2_MFP_UART0_RTS ;
  
  GPIOA->PUEN  = 2 ;                                       //PA.2
  GPIOE->PMD   = GPIO_PMD_PMD6_OUTPUT ;                    //Nano130ϵLED˸
}
////0ʼ /////////////////////////////////////////////////////////////////////
void UART0_Init(uint32_t Baud)                 
{  
  UART0->FUN_SEL = 3;                            //UART_MODE_485 ;                         
  UART0->TLCTL   = 0x3303 ;                      //8bit 1-stop no parity RTS:14,RxFiFo:14   
  UART0->BAUD    = 12000000/Baud - 1 ;           //UATR_CLK has been selected 22M  
  UART0->CTL     = UART_CTL_AUTO_CTS_EN | UART_CTL_AUTO_RTS_EN ;
}
///ʱ0,ģʽ//////////////////////////////////////////////////////////////////
void Timer0Init(void) 
{
  TIMER0->CTL    = TIMER_CTL_MODESEL_CONTINUOUS | TIMER_CTL_DBGACKEN | TIMER_CTL_TMREN ; 
  TIMER0->PRECNT = 2 ;                                     // 12MHz/3 = 4MHz
}
////  ΢ʱ //////////////////////////////////////////////////////////////////////
void Delayus(uint32_t Tim)                                 // Max Tim is 0xFFFFFF/4=4.19s 
{
  uint32_t Tick = TIMER0->DR ;
  while(((TIMER0->DR - Tick)&0xFFFFFF) <= (Tim<<2));
}
//// 0 //////////////////////////////////////////////////////////////////////
uint8_t* Tx0FillFiFo(uint8_t*pStr, uint32_t Cnt)
{  
  while(Cnt){       
    if(UART0->FSR & UART_FSR_TX_FULL_F) break ;              
	  UART0->THR = *pStr++ ;    
		--Cnt ;  
  }  
  if(Cnt)return pStr ;  
  else  return 0 ;
}

////=====================================================================================
uint8_t str[32] ;
int32_t main(void)							   
{ 
  uint8_t Cnt, *ptr, Count = 0 ;
  
  SysClkInit() ;
  GpioInit() ;
  UART0_Init(9600) ;                             //UART09600
  Tx0FillFiFo("\nUART0 OK !\n", 12) ;
  Timer0Init() ;
  
  ptr = Data ;
  UART0->TLCTL |= 0x38 ;
    
  Data[0] = 0x41 ; Data[115] = '\n' ;            //һֽڱΪ з
  
	while(1){
    Delayus(1000000);                                      //ʱ1
    GPIOE->DOUT &= ~0x40 ;                                 //ʱ,LED
    Cnt = 0 ;
    ptr = Data ;
    Data[1] = Data[0] ;                                    //ѵַ(ֽ0)дֽ1,ʾ
    Data[3] = Count / 10 ;                                 //Ѽֵ1,ַ,ʾ
    Data[4] = 0x30 + Count - Data[3]*10 ;  
    Data[3] += 0x30 ;    
    do{
      while((UART0->FSR & UART_FSR_TX_POINTER_F) >= 0x0E000000) ; //FiFoд,    
      if(GPIOA->PIN & 2){                                         //PA.2 = 1 ֽǵַ,
        if(ptr == Data)   UART0->TLCTL &= ~0x10 ;                 //ֽ0(ַ)9λΪ1
        else      UART0->TLCTL |= 0x10 ;                          //ֽڵ9λΪ0
      }        
      else UART0->TLCTL &= ~0x10 ;                         //PA.2=0, 9λȫΪ1, ޵9λ 
      UART0->THR = *ptr++ ; 
    }while(++Cnt < 116) ;

    GPIOE->DOUT |= 0x40 ;
    Data[0] += 2 ;                                         //ÿһ,ַ2, 0x510x41
    if(Data[0] >= 0x51){
      Data[0] = 0x41 ;
      if(++Count > 99) Count = 0 ;
    }
  }
}
